import tarfile
import sys, argparse, logging,os
import paramiko

debug_var = os.getenv('DEBUG')
#logFileName = '/home/epm/pylog/fastApiDebug.log'
logFileName = '/home/epm/pylog/fastApiDebug.log' if (debug_var == 'true') else '/home/epm/pylog/fastApiApp.log'
if os.path.exists(logFileName):
    os.remove(logFileName)

sysapp = logging.getLogger(__name__)
sysapp.setLevel(logging.DEBUG)
handler = logging.handlers.RotatingFileHandler(logFileName,
    maxBytes=10*1024*1024, backupCount=5,)
formatter = logging.Formatter('%(asctime)s %(filename)s[line:%(lineno)d] %(levelname)s %(message)s')
handler.setFormatter(formatter)
sysapp.addHandler(handler)


# with open('/home/epm/git/auto_deploy/gtxTs/config.json', 'r') as file:
#     configure = json.load(file)
#     sysapp.info(configure)
#     nfsPath = configure['nfs_path']
#     nasPath = configure['nas_path']
#     hanaMigPath = configure['hana_mig_path']
#     mongoMigPath = configure['mongo_mig_path']
#     port = configure['py_port']
def upload_file(local_path, remote_path, hostname, username='epm', password='Wang%2023'):
    try:
        # Create an SSH client
        ssh = paramiko.SSHClient()
        ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        
        # Connect to the remote server
        ssh.connect(hostname, username=username, password=password)
        
        # Create an SFTP client
        sftp = ssh.open_sftp()
        
        # Upload the file
        sftp.put(local_path, remote_path)
        
        # Close the SFTP and SSH connections
        sftp.close()
        ssh.close()
        
        sysapp.info(f"File uploaded successfully from {local_path} to {remote_path}")
    except Exception as e:
        sysapp.info(f"Error: {e}")

def runCommand(cmd, host, username='epm', password='Wang%2023', portNum=22):
    """
    Description: This function Execute commands remotely
    Parameters : cmd      - contains command to execute on remote host(STRING)
                 host     - hostname(IP) of remote host(STRING)
                 username - username of remote host(STRING)
                 password - password of remote host(STRING)
                 portNum  - port number of remote host(INT)(OPTIONAL)
                            default = 22
    """
    client = None
    try:
        client = paramiko.SSHClient()
        client.set_missing_host_key_policy(paramiko.AutoAddPolicy())

        sysapp.info("Connecting to host: %s", host)
        # Connects to the remote host with provided credentials
        if password != None:
            client.connect(hostname=host, username=username, password=password, port=portNum)
        else:
            client.connect(hostname=host, key_filename='/home/epm/.ssh/id_rsa', port=portNum)
        sysapp.info("Connection established with host: %s and user: %s", host, username)

        sysapp.info("Executing command: %s", cmd)
        stdin, stdout, stderr = client.exec_command(cmd)
        stdin.close()
        outputBuffer = stdout.read()
        sysapp.info("Output Stream:\n%s", outputBuffer)
        errorBufffer = stderr.read()
        sysapp.info("Error Stream:\n%s", errorBufffer)

        return outputBuffer, errorBufffer
    except Exception:
        sysapp.exception("Failed to run command '%s' on remote host %s",
                          cmd, host)
        raise
    # Dis-connects the connection of remote host
    finally:
        if client:
            client.close()

def untar(tar_file_path, destination_dir):
    with tarfile.open(tar_file_path, 'r') as tar:
        tar.extractall(path=destination_dir)